function [h,time] = SensitivityAnalysis(y)

% Finds the minimum variance portfolio using the first and second
% analytical derivatives.

tic
%y=load('j:\papers\sensitivitygarch\data\dowstocks.txt'); % Load the data file
disp(' '), disp('******************************'), disp('Start Variance Sensitivity Analysis')
[T,N]=size(y); %N=30;

% Start optimization
%
%a = unifrnd(zeros(N-1,1),ones(N-1,1)); % Random initial starting value
[h,time,a] = ewma(y); % Use EWMA optimal weigths as starting values
options=optimset('Gradobj','on','Hessian','on','Display','Iter','MaxFunEvals',200,'TolFun',0.0001);
[astar,FVAL,EXITFLAG,OUTPUT,GRAD,HESSIAN] = fminunc('GARCHsensitivity', a, options, y(:,1:N));

% Compute the data for the table
Y = y(:,1:N-1)*astar + y(:,N)*(1-astar'*ones(N-1,1)); % (T,1)-vector of portfolio returns
f = GARCH(Y);
h = f.variance(end);
time = toc;
