function output = varianceLoop(theta, y, sigma2, outtype)

% Compute the likelihood function and the time series of estimated variances.
[T,K]=size(y);

if nargin<4
	outtype=1;
	if nargin<3
      sigma2=(std(y)^2);      
	end
end

sig2=sigma2*ones(T,1);
Lik=ones(T,1);
Lik(1) = .5 * (log(2*pi) + log(sig2(1)) + (y(1)^2)/sig2(1));

for i=2:T
    sig2(i) = theta(1) + theta(2) * y(i-1)^2 + theta(3) * sig2(i-1);
    Lik(i) = .5 * (log(2*pi) + log(sig2(i)) + ((y(i)^2) / sig2(i)));
end

if outtype==1
    output = sum(Lik(1:T,:));
elseif outtype==2
    output = Lik(1:T,:);
else
    output = sig2;
end